#include <stdio.h>
#include <stdlib.h>
typedef union _realan_ceo{
	unsigned long ceo;
	float realan;
}realan_ceo;

void print_bits(unsigned int x){
	int bit_count = 8 * sizeof(unsigned int);
	unsigned int maska = 1 << (bit_count - 1);
	int i;
	for(i = 0; i < bit_count; i++){
		unsigned rez = maska & x;
		if(rez == 0)
			printf("0");
		else
			printf("1");
		//maska = maska >> 1;
		x = x << 1;
	}
	printf("\n");
}

int get_bit(unsigned int x, int k){
	unsigned int m = 1 << k;
	unsigned int rez = x & m;
	if(rez == 0)
		return 0;
	else 
		return 1;
}

unsigned int set_bit(unsigned int x, int k, int b){
	//na k-to mesto u broju x, postavlja bit b
	unsigned int m = 1 << k;
	if(b)
		return x | m;
	else
		return x & (~m);
}

int suma_bitova(unsigned int x){
	int suma = 0;
	int bc = 8 * sizeof(unsigned int);
	int i;
	unsigned m = 1;
	for(i = 0; i < bc; i++){
		unsigned rez = x & m;
		if(rez != 0)
			suma++;
		x = x >> 1;
	}
	return suma;
}

unsigned get_bits(unsigned x, int k, int n){
	unsigned rez;
	unsigned m = ~0; //11111111111111111
	m = m << n;  //111111111100000000
	m = ~m; //0000000000011111111111
	m = m << k; //0000011111111100000
	
	rez = x & m;
	return rez >> k;
}

unsigned set_bits(unsigned x, int k, int n, unsigned y){
	unsigned m1 = ~((~((~0) << n)) << k);
	unsigned m2 = ~((~0) << n);
	
	x = x & m1;
	
	y = y & m2;
	y = y << k;
	return x | y;
	
}

unsigned invert_bits(unsigned x, int k, int n){
	unsigned mask = (~((~0) << n)) << k;
	return mask ^ x;
}

int main(){
	realan_ceo a;

	unsigned int x;
	printf("-5\n");
	print_bits(-5);
	
	printf("128\n");
	print_bits(128);
	
	printf("1024\n");
	print_bits(1024);
	
	printf("1234567\n");
	print_bits(1234567);
	
	printf("nulti bit: %d\n", get_bit(1234567, 0));
	printf("peti bit: %d\n", get_bit(1234567, 5));
	printf("sedmi bit: %d\n", get_bit(1234567, 7));
	
	x = 1234567;
	x = set_bit(x, 1, 0);
	x = set_bit(x, 0, 0);
	x = set_bit(x, 29, 1);
	print_bits(x);
	
	printf("suma bitova je %d\n", suma_bitova(x));
	
	print_bits(12345678);
	print_bits(get_bits(12345678, 5, 10));
	print_bits(set_bits(12345678, 5, 8, ~0));
	
	print_bits(12345678);
	print_bits(invert_bits(12345678, 10, 10));
	
	printf("%d %d\n", sizeof(unsigned long), sizeof(unsigned int));
	
	a.realan = 3.14;
	print_bits(a.ceo);
	
	a.realan = 12345e-12;
	print_bits(a.ceo);
	
	return 0;
}